Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

Main Page | Modules | Namespace List | Class Hierarchy | Class List | Namespace Members | Class Members | Related Pages

# openvrml::mffloat Class Reference
[Field Values]

Inheritance diagram for openvrml::mffloat:

[legend]
List of all members.

## Detailed Description

A float array node field value.

Model of
  FieldValue

## Public Types
typedef std::vector< float > | value_type
| Type of value.
## Public Member Functions
| mffloat (std::vector< float >::size_type n=0, float value=0.0f) throw (std::bad_alloc)
| Construct.
| mffloat (const std::vector< float > &value) throw (std::bad_alloc)
| Construct.
template<typename InputIterator>
| mffloat (InputIterator first, InputIterator last)
| Create an mffloat with a copy of a range.
virtual | ~mffloat () throw ()
| Destroy.
virtual std::auto_ptr< field_value > | clone () const throw (std::bad_alloc)
| Virtual copy constructor.
virtual field_value & | assign (const field_value &value) throw (std::bad_cast, std::bad_alloc)
| Virtual assignment.
virtual type_id | type () const throw ()
| Get the type identifier for the class.
## Public Attributes
std::vector< float > | value
| Single precision floating point values.
## Private Member Functions
virtual void | print (std::ostream &) const
| Print to an output stream.
## Related Functions
(Note that these are not member functions.)
bool | operator== (const mffloat &lhs, const mffloat &rhs) throw()
| Compare for equality.
bool | operator!= (const mffloat &lhs, const mffloat &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mffloat &a, openvrml::mffloat &b)
| Swap the values of `a` and `b`.

## Member Typedef Documentation

openvrml::mffloat::value_type

| Type of value.

## Constructor & Destructor Documentation

openvrml::mffloat::mffloat | ( | std::vector< float >::size_type | n = `0`,
|  | float | value = `0.0f`
| ) | throw (std::bad_alloc)`[explicit]`

  | Construct. Creates an mffloat with `n` copies of `value`. Parameters:
  | n | the number of elements in the mffloat.
  | value | used to initialize the mffloat.
  Exceptions:
  | std::bad_alloc | if memory allocation fails.
Postcondition: size is `n`. Every element is a copy of `value`.

openvrml::mffloat::mffloat | ( | const std::vector< float > & | value | ) | throw (std::bad_alloc)`[explicit]`

  | Construct. Parameters:
  | value | initial value.
  Exceptions:
  | std::bad_alloc | if memory allocation fails.

template<typename InputIterator>
openvrml::mffloat::mffloat | ( | InputIterator | first,
|  | InputIterator | last
| ) |

  | Create an mffloat with a copy of a range. Creates an mffloat with a value that is a copy of the range [`first`, `last`). Parameters:
  | first | an iterator pointing to the beginning of the range.
  | last | an iterator pointing one past the end of the range.

openvrml::mffloat::~mffloat | ( |  | ) | throw ()`[virtual]`

| Destroy. Each of the mffloat's value elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

std::auto_ptr< field_value > openvrml::mffloat::clone | ( |  | ) | const throw (std::bad_alloc)`[virtual]`

  | Virtual copy constructor. Returns: a pointer to a copy of the object. Exceptions:
  | std::bad_alloc | if memory allocation fails.
Implements openvrml::field_value.

field_value & openvrml::mffloat::assign | ( | const field_value & | value | ) | throw (std::bad_cast, std::bad_alloc)`[virtual]`

  | Virtual assignment. Returns: a reference to the object. Exceptions:
  | std::bad_cast | if `value` is not an mffloat object.
  | std::bad_alloc | if memory allocation fails.
Implements openvrml::field_value.

field_value::type_id openvrml::mffloat::type | ( |  | ) | const throw ()`[virtual]`

| Get the type identifier for the class. Returns: `field_value::mffloat_id`. Implements openvrml::field_value.

void openvrml::mffloat::print | ( | std::ostream & | out | ) | const`[private, virtual]`

  | Print to an output stream. Parameters:
  | out | an output stream.
Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mffloat & | lhs,
|  | const mffloat & | rhs
| ) | throw()`[related]`

  | Compare for equality. Parameters:
  | lhs | left-hand operand.
  | rhs | right-hand operand.
Returns: `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mffloat & | lhs,
|  | const mffloat & | rhs
| ) | throw()`[related]`

  | Compare for inequality. Parameters:
  | lhs | left-hand operand.
  | rhs | right-hand operand.
Returns: `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mffloat & | a,
|  | openvrml::mffloat & | b
| ) | `[related]`

  | Swap the values of `a` and `b`. Does not throw. Parameters:
  | a |
  | b |

## Member Data Documentation

std::vector< float > openvrml::mffloat::value

| Single precision floating point values.